unit base;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, base64,Dialogs,Graphics, StdCtrls,FileUtil,
  process,Forms,resource,versiontypes,versionresource
{$IFDEF WIN64}
  ,winsock
{$ENDIF}
  ;

Const
    ret = #10;
    HK  = #39;        // Hochkomma für Strings
    backtick = #96;

    RaumAnzMax = 10;
    PCAnzMax = 40;

  Programm_sec = 'Programm';
    Name_entry    = 'Name';
    xpos_entry    = 'xpos';
    ypos_entry    = 'ypos';
    Width_entry   = 'width';
    Height_entry  = 'height';
    Border_entry  = 'BorderStyle';
    debug_entry   = 'debug';
    SchalterAnz_entry = 'ButtonAnzahl';
    FixPos_entry      = 'FixedPosition';
    Raumanzahl_entry  = 'Raumanzahl';
    PCListvisible_entry = 'PCListeVisible';
    Nachrichtvisible_entry = 'SendeNachrichtVisible';
    Befehlvisible_entry    = 'SendeBefehlVisible';
    WOLDelay_entry      = 'WOLDelay';
    SperrBild_entry     = 'SperrBild';
    mitUhr_entry        = 'mitUhr';
    VNCPort_entry       = 'VNCPort';
    VNCPassPfad_entry   = 'VNCPassPfad';
    VNCPasstext_entry   = 'VNCPassPfad_text';
    AdminUsers_entry    = 'AdminUsers';
    UltraVNCPfad_entry  = 'UltraVNCPfad';
    SleepTimeSSL_entry  = 'SleepTimeSSL';
    SleepTimeTCP_entry  = 'SleepTimeTCP';
    SleepTimeNAC_entry  = 'SleepTimeNAC';
    BTInternet_entry    = 'Internetsperre';
    BTDrucker_entry     = 'Druckersperre';
    ServerIP_entry      = 'ServerIP';

  Windows_sec         = 'Windows';
    WOL_entry         = 'WOLPfad';

  Raum_sec     = 'Raum';
    RaumName_entry   = 'Raumname';
    PCAnz_entry      = 'PC-Anzahl';
    LehrerIP_entry   = 'LehrerIP';
    SchuelerIP_entry = 'SchuelerIP';

  Schalter_sec = 'Button';
    Befehl_entry = 'exec';
    Show_entry   = 'BefehlsAusgabeAnzeigen';

  MausDienst_sec   = 'MausDienst';
    Port_entry     = 'Port';
    UseSSL_entry   = 'UseSSL';
    Taskmgr_entry  = 'DisableTaskmgr';
    UseAuth_entry  = 'UseAuth';
    Farbe_entry    = 'Farbe';
    Text_entry     = 'Text';
    MasterIP_entry = 'AcceptMaster';

  msg_AUTH = 'AUTH';
  msg_INON = 'INON';   msg_INOF = 'INOF';
  msg_DRON = 'DRON';   msg_DROF = 'DROF';

Var
    ServerIP, FirewallIP : String;
    debug,FixPos  : Boolean;
    SperrBild, mitUhr     : Boolean;
    Bin_Admin, AuthOK     : Boolean;
    AdminUsers    : String;
    MyBenutzer,MyPass : String;
    Xpos,Ypos     : integer;
    Breite, Breite_win,  Breite_lin : Integer;
    Hoehe, Hoehe_win,  Hoehe_lin    : Integer;
    BStyle        : String;
    WOLDelay      : integer;
    VNCPort       : integer;
    VNCPassPfad   : String;
    VNCPassName   : String;
    VNCPassPfad_text   : String;
    VNCPasstext   : String;
    WOLPfad, WOLName                 : String;
    UltraVNCPfad : String;
    Nachricht_vis, Befehle_vis : Boolean;
    BT_Internet_vis, BT_Drucker_vis : Boolean;

    UseAuthSK  : Integer;
    SKPort     : Integer;
    ConnectOK  : Boolean;

    AktRaum       : integer;
    RaumAnz       : integer;
    ConfigFilePfad : String;

    Prog_Name     : String;

    PCAnz        : Array [1..RaumAnzMax] of integer;
    RaumName     : Array [1..RaumAnzMax] of String;
    LehrerIP     : Array [1..RaumAnzMax] of String;
    LehrerMAC    : Array [1..RaumAnzMax] of String;
    LehrerPC     : Array [1..RaumAnzMax] of String;
    LehrerPCTyp  : Array [1..RaumAnzMax] of String;

    SchuelerIP   : Array [1..RaumAnzMax,1..PCAnzMax] of String;
    SchuelerMAC  : Array [1..RaumAnzMax,1..PCAnzMax] of String;
    SchuelerPC   : Array [1..RaumAnzMax,1..PCAnzMax] of String;
    SchuelerPCTyp: Array [1..RaumAnzMax,1..PCAnzMax] of String;

    SetLIP     : Array [1..RaumAnzMax] of integer;

    MausDienstPort : Integer;
    UseSSL,UseAuth : Boolean;

    SleepTimeSSL, SleepTimeTCP, SleepTimeNAC : integer;


Function validIP(IP : String):Boolean;
Function validMAC(MAC : String):Boolean;
Function IPauslesen:string;
Function AlleIPauslesen:String;
Function Maskeauslesen:string;
Function ZerlegeIP(IP:string; VAR b1,b2,b3,b4 : integer): Boolean;
Function Ping(IP:String):real;
procedure Split(Delimiter: Char; Str: string; ListOfStrings: TStrings) ;
Function du_MB(pfad : string):real;
Function du_byte(pfad : string) : integer;
Function Befehl_exec(Befehl : String):String;
Function Befehl_execF(Befehl : String):String;
Function Befehl_execS(Befehl : String):String;
Function Befehl_execH(Befehl : String):String;
Function KernelInfo_sh:String;
Function KernelDel_sh:String;
FUNCTION resourceVersionInfo: STRING;
Function GetBenutzer : String;
function vtr(t:String):String;


implementation

Function validIP(IP : string):Boolean;
Const
  zeichen = '0123456789.';
  bmax = 255;
Var
  n,L,pp      : integer;
  p1,p2,p3    : integer;
  b1,b2,b3,b4 : integer;
  s           : String;
Begin
 s  := Trim(IP);
 result := false;
 L  := length(s);
 pp := 0;
 for n:= 1 to L do
   Begin
     if pos(s[n],zeichen)=0 then exit;
     if s[n]='.' then inc(PP);
   end;
 if pp <> 3 then exit;
 p1 := pos('.',s);
 b1 := StrToIntDef(Copy(S,1,p1-1),bmax+1);
 s  := Copy(S,p1+1,L);
 p2 := pos('.',s);
 b2 := StrToIntDef(Copy(S,1,p2-1),bmax+1);
 s  := Copy(S,p2+1,L);
 p3 := pos('.',s);
 b3 := StrToIntDef(Copy(S,1,p3-1),bmax+1);
 b4 := StrToIntDef(Copy(S,p3+1,L),bmax+1);
 if (b1 <= bmax) and (b2 <= bmax)  and (b3 <= bmax) and (b4 <= bmax) then result := True;
end;

Function validMAC(MAC : string):Boolean;
Const
  zeichen = '0123456789abcdef';
  trenner = ':-';
  Var
    m    : String;
    t,z, n : Integer;
Begin
  result := false;
  m := Trim(lowercase(MAC));
  if length(m)=0 then exit;
  t := 0;
  z := 0;
  for n := 1 to length(m) do
    Begin
      if (pos(m[n],trenner)>0 )  then inc(t);
      if (pos(m[n],zeichen)>0 )  then inc(z);
    end;
  if ((t=0) or (t=5)) and (z = 12)  then result := true;
end;

Function ZerlegeIP(IP:string; VAR b1,b2,b3,b4 : integer):Boolean;
Const
  zeichen = '0123456789.';
  bmax = 255;
Var
  n,L,pp      : integer;
  p1,p2,p3    : integer;
  s           : String;
Begin
 s  := Trim(IP);
 result := false;
 L  := length(s);
 pp := 0;
 for n:= 1 to L do
   Begin
     if pos(s[n],zeichen)=0 then exit;
     if s[n]='.' then inc(PP);
   end;
 if pp <> 3 then exit;
 p1 := pos('.',s);
 b1 := StrToIntDef(Copy(S,1,p1-1),bmax+1);
 s  := Copy(S,p1+1,L);
 p2 := pos('.',s);
 b2 := StrToIntDef(Copy(S,1,p2-1),bmax+1);
 s  := Copy(S,p2+1,L);
 p3 := pos('.',s);
 b3 := StrToIntDef(Copy(S,1,p3-1),bmax+1);
 b4 := StrToIntDef(Copy(S,p3+1,L),bmax+1);
 if (b1 <= bmax) and (b2 <= bmax)  and (b3 <= bmax) and (b4 <= bmax) then result := True;
end;

function AlleIPauslesen: String;
{$IFDEF WIN64}
type PPInAddr= ^PInAddr;
var
      wsaData : TWSAData;
      HostInfo : PHostEnt;
      HostName : Array[0..255] of Char;
      Addr : PPInAddr;
begin
      Result:='';
      if WSAStartup($0102, wsaData) <> 0 then
        Exit;
      try
        if GetHostName(HostName, SizeOf(HostName)) <> 0 then
          Exit;
        HostInfo:= GetHostByName(HostName);
        if HostInfo=nil then
          Exit;
        Addr:=Pointer(HostInfo^.h_addr_list);
        if (Addr=nil) or (Addr^=nil) then
          Exit;
        Result:=StrPas(inet_ntoa(Addr^^));
        inc(Addr);
        while Addr^ <> nil do begin
          Result:=Result+ret+StrPas(inet_ntoa(Addr^^));
          inc(Addr);
        end;
      finally
        WSACleanup;
      end;
end;
{$ENDIF}
{$IFDEF Linux}
Begin
  Result := IPauslesen;
end;
{$ENDIF}



function ipauslesen:string;
{$IFDEF WIN64}
var
  rSockVer   : WordRec;
  aWSAData   : TWSAData;
  szHostName : array[0..255] of Char;
  pHE        : PHostEnt;
  sIP        : String;
begin
  // WinSock Version 1.1 initialisieren
  rSockVer.Hi := 1;
  rSockVer.Lo := 1;
  WSAStartup(Word(rSockVer), aWSAData );
  try
    FillChar(szHostName, SizeOf(szHostName), #0);
    GetHostName(szHostName, SizeOf(szHostName));
    pHE := GetHostByName(szHostName);
    if Assigned(pHE)
      then with pHE^ do
        sIP := Format('%d.%d.%d.%d',[Byte(h_addr^[0]), Byte(h_addr^[1]),Byte(h_addr^[2]), Byte(h_addr^[3])]);
  finally
    WSACleanup;
  end;
  result:= sIP;
end;
{$ENDIF}
{$IFDEF Linux}
Var
  ifconfig : TProcess;
  Ausgabe  : TStringList;
  ipListe  : TStringList;
  n,p1,p2  : integer;
begin
  ifconfig := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  ipListe  := TStringList.create;
  ifconfig.CommandLine := '/sbin/ifconfig';

    ifconfig.Options := ifconfig.Options+[poWaitOnExit,poUsePipes] ;
    ifconfig.execute;
    Ausgabe.LoadFromStream(ifconfig.output);
    result:='';
    if (Ausgabe.Count > 0) then
      Begin
        for n:= 0 to Ausgabe.count-1 do
          Begin
            p1 := Pos('inet Adresse',Ausgabe[n]);
            p2 := Pos('Bcast:',Ausgabe[n]);
            if (p1 > 0) and (p2 > 0) and (p2>p1+21)then
              Begin
                ipListe.append(Copy(Ausgabe[n],p1+13,p2-p1-15));
                break;
              end;
          end;
        result:=ipListe.text;
      end
    else
      Begin
        result :='';
      end;
  ifconfig.free;
  Ausgabe.free;
  ipListe.free;
end;
{$ENDIF}

function Maskeauslesen:string;
Var
  ifconfig   : TProcess;
  Ausgabe    : TStringList;
  IPListe    : TStringList;
  n,p1,p2,p3 : integer;
begin
  ifconfig := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  ipListe  := TStringList.create;
    ifconfig.CommandLine := '/sbin/ifconfig';
    ifconfig.Options := ifconfig.Options+[poWaitOnExit,poUsePipes] ;
    ifconfig.execute;
    Ausgabe.LoadFromStream(ifconfig.output);
    result:='';
    if (Ausgabe.Count > 0) then
      Begin
        for n:= 0 to Ausgabe.count-1 do
          Begin
            p1 := Pos('inet Adresse',Ausgabe[n]);
            p2 := Pos('Bcast:',Ausgabe[n]);
            p3 := Pos('Maske:',Ausgabe[n]);
            if (p1 > 0) and (p2 > 0) and (p2>p1+21) and (p3>p2) then
              Begin
                ipListe.append(Trim(Copy(Ausgabe[n],p3+6,15)));
                break;
              end;
          end;
        result:=ipListe.text;
      end
    else
      Begin
        result :='';
      end;
  ifconfig.free;
  Ausgabe.free;
  ipListe.free;
end;

function Ping(IP:string):real;
Var
  Befehl      : TProcess;
  Ausgabe     : TStringList;
  n,p1,p2,p3  : integer;
  zeit        : real;
  Empfang     : Boolean;
begin
  Befehl   := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  Befehl.commandline := '/bin/ping -c1 '+IP;
  Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
  Befehl.Execute;
  Ausgabe.LoadFromStream(Befehl.Output);
  // ShowMessage(Ausgabe.text);
  Empfang  := false;
    if (Ausgabe.Count > 0) then
      Begin
        for n:= 0 to Ausgabe.count-1 do
          Begin
            p1 := Pos('time=',Ausgabe[n]);
            p2 := Pos('ms',Ausgabe[n]);
            p3 := Pos('1 received',Ausgabe[n]);
            if (p1 > 0) and (p2 > 0) and (p2>p1) then
              Begin
                zeit := StrToFloat(Copy(Ausgabe[n],p1+5,p2-p1-5));
              end;
            if p3 > 0 then Empfang := True;
          end;
      end;
  if not Empfang then result := -1
                 else result := zeit;
  Befehl.free;
  Ausgabe.free;
end;

procedure Split(Delimiter: Char; Str: string; ListOfStrings: TStrings) ;
begin
   ListOfStrings.Clear;
   ListOfStrings.Delimiter     := Delimiter;
   ListOfStrings.DelimitedText := Str;
end;

Function du_MB(Pfad : String):real;
Const
  ziffern = '0123456789';
Var
  Befehl  : TProcess;
  Ausgabe : TStringList;
  n       : integer;
  Zeile   : String;
Begin
 Befehl   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Befehl.commandline := 'sh -c "/usr/bin/du -sc '+Pfad+'"';
 Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
 Befehl.Execute;
 Ausgabe.LoadFromStream(Befehl.Output);
 Zeile := Ausgabe[Ausgabe.count-1];
 n := Pos('insgesamt',Zeile);
 //ShowMessage(Befehl.commandline+ret+Ausgabe.text);
 if n=0 then result := 0
        else result := StrToInt(Trim(Copy(Zeile,1,n-1))) / 1024;
 Befehl.free;
 Ausgabe.free;;
end;

Function du_byte(Pfad : String):integer;
Const
  ziffern = '0123456789';
Var
  Befehl  : TProcess;
  Ausgabe : TStringList;
  n       : integer;
  Zeile   : String;
Begin
 if not FileExists(Pfad) then
   Begin
     result := -1
   end
 else
   Begin
     Befehl   := TProcess.Create(nil);
     Ausgabe  := TStringList.create;
     Befehl.commandline := 'sh -c "/usr/bin/du -bc '+Pfad+'"';
     Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
     Befehl.Execute;
     Ausgabe.LoadFromStream(Befehl.Output);
     Zeile := Ausgabe[Ausgabe.count-1];
     n :=0;
     While (Pos(Zeile[n+1],ziffern)>0) do inc(n);
     if n = 0 then result := -1
              else result := StrToInt(Trim(Copy(Zeile,1,n)));
     Befehl.free;
     Ausgabe.free;;
   end;
end;

Function Befehl_exec(Befehl : String):String;
Var
  PRC     : TProcess;
  Ausgabe : TStringList;
Begin
 PRC   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 PRC.commandline := Befehl;
 PRC.Options := PRC.Options + [poWaitOnExit, poUsePipes];
 PRC.Execute;
 Ausgabe.LoadFromStream(PRC.Output);
 Result := Ausgabe.text;
 PRC.free;
 Ausgabe.free;
 end;

Function Befehl_execS(Befehl : String):String;
Var
  PRC     : TProcess;
  Ausgabe : TStringList;
Begin
 PRC   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 PRC.commandline := Befehl;
 //PRC.Options := PRC.Options + [poUsePipes];
 PRC.Execute;
 //Ausgabe.LoadFromStream(PRC.Output);
 //Result := Ausgabe.text;
 PRC.free;
 Ausgabe.free;
 end;

Function Befehl_execH(Befehl : String):String;   // mit verstecktem Konsolenfenster
Var
  PRC     : TProcess;
Begin
 PRC   := TProcess.Create(nil);
 PRC.commandline := Befehl;
 PRC.ShowWindow:= swoHIDE;
 PRC.Execute;
 PRC.free;
end;


Function Befehl_execF(Befehl : String):String;     // mit Fehlerausgabe
Var
  PRC  : TProcess;
  Ausgabe, Fehler : TStringList;
Begin
 PRC   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Fehler   := TStringList.create;
 PRC.commandline := Befehl;
 PRC.Options := PRC.Options + [poWaitOnExit, poUsePipes];
 PRC.Execute;
 Ausgabe.LoadFromStream(PRC.Output);
 Fehler.LoadFromStream(PRC.StDerr);
 Result := Trim(Ausgabe.text+ret+ret+Fehler.text);
 PRC.free;
 Ausgabe.free;
 Fehler.free;
end;

Function KernelInfo_sh:String;
Var
  Befehl    : TProcess;
  Ausgabe   : TStringList;
  Pfad,s    : String;
  p1,p2,n   : integer;
Begin
 Befehl   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Pfad     :=  ExtractFilePath(Application.ExeName);
 Befehl.commandline := Pfad+'kernelinfo.sh';
 Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
 Befehl.Execute;
 Ausgabe.LoadFromStream(Befehl.Output);
 //ShowMessage(Befehl.commandline+ret+Ausgabe.text);
 if Ausgabe.count >0 then
   Begin
     for n := 0 to Ausgabe.count-1 do
       begin
         p1 := pos('neu installiert',Ausgabe[n]);
         p2 := pos('zu entfernen',Ausgabe[n]);
         if (p1>0) and (p2>0) then
           Begin
             s := Copy(Ausgabe[n],p1+17, p2-p1-18);
             result := s+' Pakete';
           end;
       end;
   end
 else
   begin
     Result := 'keine Info'
   end;
 Befehl.free;
 Ausgabe.free;;
end;

Function KernelDel_sh:String;
Var
  Befehl    : TProcess;
  Ausgabe   : TStringList;
  Pfad,s    : String;
  p1,p2,n   : integer;
Begin
 Befehl   := TProcess.Create(nil);
 Ausgabe  := TStringList.create;
 Pfad     :=  ExtractFilePath(Application.ExeName);
 Befehl.commandline := Pfad+'kerneldel.sh';
 Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
 Befehl.Execute;
 Ausgabe.LoadFromStream(Befehl.Output);
 //ShowMessage(Befehl.commandline+ret+Ausgabe.text);
 if Ausgabe.count >0 then
   Begin
     for n := 0 to Ausgabe.count-1 do
       begin
         p1 := pos('neu installiert',Ausgabe[n]);
         p2 := pos('zu entfernen',Ausgabe[n]);
         if (p1>0) and (p2>0) then
           Begin
             s := Copy(Ausgabe[n],p1+17, p2-p1-18);
             result := s+' Pakete';
           end;
       end;
   end
 else
   begin
     Result := 'keine Info'
   end;
 Befehl.free;
 Ausgabe.free;;
end;
FUNCTION resourceVersionInfo: STRING;

 (* Unlike most of AboutText (below), this takes significant activity at run-    *)
 (* time to extract version/release/build numbers from resource information      *)
 (* appended to the binary.                                                      *)

 VAR     Stream: TResourceStream;
         vr: TVersionResource;
         fi: TVersionFixedInfo;

 BEGIN
   RESULT:= '';
   TRY

 (* This raises an exception if version info has not been incorporated into the  *)
 (* binary (Lazarus Project -> Project Options -> Version Info -> Version        *)
 (* numbering).                                                                  *)

     Stream:= TResourceStream.CreateFromID(HINSTANCE, 1, PChar(RT_VERSION));
     TRY
       vr:= TVersionResource.Create;
       TRY
         vr.SetCustomRawDataStream(Stream);
         fi:= vr.FixedInfo;
         RESULT := 'Version ' + IntToStr(fi.FileVersion[0]) + '.' + IntToStr(fi.FileVersion[1]) +
                ' release ' + IntToStr(fi.FileVersion[2]) + ' build ' + IntToStr(fi.FileVersion[3]); // + eol;
         vr.SetCustomRawDataStream(nil)
       FINALLY
         vr.Free
       END
     FINALLY
       Stream.Free
     END
   EXCEPT
   END
 END { resourceVersionInfo } ;

Function GetBenutzer : String;
Begin
 {$IFDEF WIN64}
  Result    := GetEnvironmentVariable(String('USERNAME'));
{$ENDIF}
{$IFDEF Linux}
  Result    := GetEnvironmentVariable('USER');
{$ENDIF}
end;

function vtr(t:String):String;
Var
  n,l : integer;
  r,s   : String;
Begin
 r := '';
 s := t;
 l := length(t);
 if (l mod 2) = 1 then
   Begin
     r := t[l];
     l := l-1;
     s := copy(s,1,l);
   end;
 l := l div 2;
 for n := 1 to l do
   Begin
     r := s[n*2-1]+s[n*2]+r
   end;
 result := r;
end;


end.
