unit ImportUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  base;

Const
  RAnzMax = 30;    // Maximale Zahl der auswählbaren Räume


type

  { TImportForm }

  TImportForm = class(TForm)
    BT_importieren: TButton;
    BT_Abbrechen: TButton;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    procedure BT_AbbrechenClick(Sender: TObject);
    procedure BT_importierenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    CBox    : Array[1..RAnzMax] of TCheckBox;
    { private declarations }
  public
    Ranz : integer;
    ImportOK : Boolean;
    IPS     : Array[1..RAnzMax,1..PCAnzMax] of String;
    MACS    : Array[1..RAnzMax,1..PCAnzMax] of String;
    PCName  : Array[1..RAnzMax,1..PCAnzMax] of String;
    IPAnz   : Array[1..PCAnzMax] of integer;
    Rname  : Array[1..RAnzMax] of String;

    { public declarations }
  end;

var
  ImportForm: TImportForm;

implementation

{$R *.lfm}

{ TImportForm }

procedure TImportForm.BT_AbbrechenClick(Sender: TObject);
var
  n : integer;
begin
  for n:= 1 to Ranz do CBox[n].free;
  Ranz :=0;
  close;
end;

procedure TImportForm.BT_importierenClick(Sender: TObject);
Var
  n,m : integer;
  s : String;
begin
  s := '';
  for n := 1 to Ranz do
    Begin
      if CBox[n].checked then s:= s + Rname[n]+ret;
    end;
  if s='' then
  Begin
    ShowMessage('Problem!'+ret+ret+'Keine Räume ausgewählt');
    exit;
  end;
  if MessageDlg('Räume importieren','Möchten Sie die ausgewählten Räume:'+ret+s+
                'importieren?',mtConfirmation,[mbNo,mbYes],0) = mrYes then
    Begin
      for n := 1 to Ranz do
        Begin
          if not CBox[n].checked then IPAnz[n] :=0;
          CBox[n].free;
        end;
      ImportOK := True;
      close;
    end;
end;

procedure TImportForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
end;

procedure TImportForm.FormShow(Sender: TObject);
Var
  Datei,Zeile : TStringList;
  n,m,a,z,ip_start,mac_start,name_start,name_end : integer;
  s, r, ip : String;
  Rnummer   : integer;
  gefunden,maxraum : boolean;
  CB_Max   : Integer;
begin
  ImportOK := false;
  ShowMessage('Für den Import benötigen Sie die workstations-Datei vom Server, aus der die Räume und IPs der Computer herausgefiltert werden.');
  if OpenDialog1.Execute then
    Begin
      Datei := TStringList.create;
      Zeile := TStringList.create;
      Datei.LoadFromFile(OpenDialog1.FileName);
      RAnz := 0;
      maxraum := false;
      for n:= 0 to Datei.Count-1 do
        Begin
          s := Trim(Datei[n]);
          z :=0;
          ip_start := 0;
          r := '';
          ip := '';
          if (length(s)>0) then if (s[1]<>'#') then
          for m := 1 to length(s) do
            Begin
              if s[m]=';' then
                Begin
                  inc(z);
                  if z=1 then
                    Begin
                      Name_start := m;
                      r := Trim(Copy(s,1,m-1));
                      gefunden := false;
                      for a:= 1 to Ranz do
                        Begin
                          if r = Rname[a] then
                            Begin
                              gefunden := true;
                              Rnummer := a;
                              break;
                            end;
                        end;
                      if not gefunden then
                        Begin
                          if (Ranz < RAnzMax) then inc(Ranz)
                          else
                            Begin
                              if not maxraum then ShowMessage('Die maximale Raumanzahl ist erreicht.'+ret+'Bitte Workstations-Datei manuell einschränken.');
                              maxraum := True;
                            end;
                          Rname[Ranz]:=r;
                          Rnummer := Ranz;
                          IPAnz[Ranz] :=0;
                        end;
                    end;
                  if z=2 then name_end:=m;
                  if z=3 then mac_start:=m;
                  if z=4 then ip_start:=m;
                  if z=5 then
                    Begin
                      ip:= Copy(s,ip_start+1,m-ip_start-1);
                      if validIP(ip) and (IPAnz[Rnummer] < PCAnzMax) then
                        Begin
                          inc(IPAnz[Rnummer]);
                          IPs[Rnummer,IPAnz[Rnummer]] :=ip;
                          MACs[Rnummer,IPAnz[Rnummer]]:=Copy(s,MAC_start+1,ip_start-MAC_start-1);
                          PCName[Rnummer,IPAnz[Rnummer]]:=Copy(s,Name_start+1,Name_end-Name_start-1);
                        end;
                    end;
                end;
            end;
        end;
      Datei.free;
      Zeile.free;
      CB_Max := 15;
      if RAnz =0 then
      Begin
        ShowMessage('Problem!'+ret+ret+'Es konnten keine auswertbaren Daten gefunden werden.');
        close;
      end;
      for n := 1 to Ranz do
        Begin
          CBox[n] := TCheckBox.create(self);
          CBox[n].parent := self;
          CBox[n].tag    := n;
          CBox[n].caption := Rname[n]+' ('+IntToStr(IPAnz[n])+' Geräte)';
          if n<=CB_Max then
            Begin
              CBox[n].top := n*25;
              CBox[n].left := 10;
            end
          else
            Begin
              CBox[n].top := (n-CB_Max)*25;
              CBox[n].left := 230;
            end;
          CBox[n].Height:=20;
          CBox[n].Width := width-20;
        end;
      Height := CBox[Ranz].top+25+10;
    end
  else
    begin
      RAnz := 0;
      close;
    end;
end;

end.

