unit pclistunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, base, Process, AsyncProcess;

type

  { TPCLIstForm }

  TPCLIstForm = class(TForm)
    PCmemo: TMemo;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    n_PC        : integer;
    PingProcess : TAsyncProcess;
    SchuelerPing : Array[1..RaumAnzMax,1..PCAnzMax] of real;
    SchuelerName : Array[1..RaumAnzMax,1..PCAnzMax] of string;
    { private declarations }
  public
    delta_y : integer;
    { public declarations }
  end;

var
  PCLIstForm: TPCLIstForm;

implementation

{$R *.lfm}

{ TPCLIstForm }


procedure TPCLIstForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  timer1.Enabled:=false;
  PingProcess := nil;
  n_PC :=0;
end;

procedure TPCLIstForm.FormShow(Sender: TObject);
Var
   n,h    : integer;
   s    : string;
   t    : real;
begin
  if xpos>0 then Left := xpos
            else Left := Screen.DesktopWidth+xpos-width;
  if ypos>0 then top := ypos+Delta_y
            else top := -ypos;
  timer1.enabled := true;
  PCmemo.clear;
  n_PC :=0;
  for n := 1 to PCAnz[AktRaum] do
    Begin
      PCmemo.append(IntToStr(n)+'. '+SchuelerIP[AktRaum,n]);
      SchuelerPing[AktRaum,n]:=-1;
      SchuelerName[AktRaum,n]:='';
    end;
  PCMemo.CaretPos:=Point(0,0);
  h := PCAnz[AktRaum]*18;
  if (h > (Screen.DesktopHeight div 2)) then h := Screen.DesktopHeight div 2;
  PCMemo.Height:=h;
  Height := h+4;
end;

procedure TPCLIstForm.Timer1Timer(Sender: TObject);
var
  t                    : real;
  Empfang              : boolean;
  n,p1,p2,p3           : integer;
  s, IP,BN, SSH_Befehl : String;
  Ausgabe,Zeile        : TStringList;
begin
  if not assigned(PingProcess) then
    Begin
      inc(n_PC);
      if (n_PC > PCAnz[AktRaum]) then n_PC :=1;
      IP := SchuelerIP[AktRaum,n_PC];
      if SchuelerPing[AktRaum,n_PC]>=0 then
        Begin
          //SSH_Befehl := 'ssh -o "StrictHostKeyChecking no" -i '+PrivKeyPfad+' -l root '+IP+' who -us';
          s := Befehl_exec(SSH_Befehl);
          Ausgabe := TStringList.create;
          Zeile   := TStringList.create;
          Ausgabe.text := s;
          BN := 'NN';
          for n := 0 to Ausgabe.count-1 do
            Begin
             Split(' ',Ausgabe[n],Zeile);
             if Zeile.count>1 then
                Begin
                  if Zeile[1]=':0' then BN := Trim(Zeile[0]);
                  if Zeile[1]='tty7' then BN := Trim(Zeile[0]);
                end;
             end;
          Zeile.free;
          Ausgabe.free;
          SchuelerName[AktRaum,n_PC] := BN;
          PCmemo.Lines[n_PC-1] := IntToStr(n_PC)+'. '+IP+' ('+FloatToStrF(SchuelerPing[AktRaum,n_PC],ffFixed,10,3)+
                                  ' ms)  '+SchuelerName[AktRaum,n_PC];
          PCMemo.CaretPos:=Point(0,0);
          PCListForm.Update;
          SchuelerPing[AktRaum,n_PC]:=-1;
        end
      else
        Begin
          PingProcess := TAsyncProcess.create(nil);
          PingProcess.commandline := '/bin/ping -c1 '+IP;
          PingProcess.Options := PingProcess.Options + [poUsePipes];
          PingProcess.Execute;
        end;
    end
  else
    Begin
      if not PingProcess.Running then
        Begin
          Ausgabe := TStringList.create;
          Ausgabe.LoadFromStream(PingProcess.output);
          if (Ausgabe.Count > 0) then
            Begin
              Empfang := false;
              for n:= 0 to Ausgabe.count-1 do
                  Begin
                    p1 := Pos('time=',Ausgabe[n]);
                    p2 := Pos('ms',Ausgabe[n]);
                    p3 := Pos('1 received',Ausgabe[n]);
                    if (p1 > 0) and (p2 > 0) and (p2>p1) then
                      Begin
                        t := StrToFloat(Copy(Ausgabe[n],p1+5,p2-p1-5));
                      end;
                    if (p3 > 0) then Empfang := True;
                  end;
              if not Empfang then t := -1;
              SchuelerPing[AktRaum,n_PC]:=t;
              if (n_PC>=1) then
                 Begin
                      if (t >=0 ) then s := ' ('+FloatToStrF(t,ffFixed,10,3)+' ms)  '+SchuelerName[AktRaum,n_PC]
                                  else s := ' ... nicht erreichbar';
                      PCmemo.Lines[n_PC-1] := IntToStr(n_PC)+'. '+SchuelerIP[AktRaum,n_PC]+s;
                      PCMemo.CaretPos:=Point(0,0);
                      PCListForm.Update;
                 end;
           end;
          Ausgabe.free;
          PingProcess.free;
          PingProcess := nil;
        end;
    end;
end;


end.

