unit Raumunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids, base, IniFiles, process, Konfigurationsunit, ImportUnit;

type

  { TRaumKonfiguration }

  TRaumKonfiguration = class(TForm)
    Beenden: TButton;
    BT_Speichern: TButton;
    BT_Loesch: TButton;
    BT_neu: TButton;
    BT_workstations: TButton;
    BT_Zeile: TButton;
    Ed_LehrerIP: TEdit;
    Ed_RaumName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    RaumBox: TComboBox;
    PC_Grid: TStringGrid;
    procedure BeendenClick(Sender: TObject);
    procedure BT_LoeschClick(Sender: TObject);
    procedure BT_neuClick(Sender: TObject);
    procedure BT_SpeichernClick(Sender: TObject);
    procedure BT_workstationsClick(Sender: TObject);
    procedure BT_ZeileClick(Sender: TObject);
    procedure Ed_LehrerIPChange(Sender: TObject);
    procedure Ed_RaumNameChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PC_GridEnter(Sender: TObject);
    procedure PC_GridExit(Sender: TObject);
    procedure RaumBoxChange(Sender: TObject);
  private
    Raum     : integer;
    Procedure veraendert;

    { private declarations }
  public
    RaumName_new    : Array [1..RaumAnzMax] of String;
    PCAnz_new       : Array [1..RaumAnzMax] of integer;
    LehrerIP_new    : Array [1..RaumAnzMax] of String;
    LehrerMAC_new   : Array [1..RaumAnzMax] of String;
    LehrerPC_new    : Array [1..RaumAnzMax] of String;
    LehrerPCTyp_new : Array [1..RaumAnzMax] of String;

    SchuelerIP_new   : Array [1..RaumAnzMax,1..PCAnzMax] of String;
    SchuelerMAC_new  : Array [1..RaumAnzMax,1..PCAnzMax] of String;
    SchuelerPC_new   : Array [1..RaumAnzMax,1..PCAnzMax] of String;
    SchuelerPCTyp_new: Array [1..RaumAnzMax,1..PCAnzMax] of String;

    RaumAnz_new    : integer;
    { public declarations }
  end;

var
  RaumKonfiguration: TRaumKonfiguration;


implementation

{$R *.lfm}

{ TRaumKonfiguration }

procedure TRaumKonfiguration.RaumBoxChange(Sender: TObject);
Var
  n          : integer;
  mac,pc,typ : String;
begin
  Raum := RaumBox.ItemIndex+1;
  ED_LehrerIP.text := LehrerIP_new[Raum];
  ED_RaumName.text := RaumName_new[Raum];
  PC_Grid.RowCount:=PCAnz_new[Raum]+1;
  for n := 1 to PCAnz_new[Raum] do
    Begin
      PC_Grid.Cells[0,n]:= IntToStr(n);
      PC_Grid.Cells[1,n]:= SchuelerIP_new[Raum,n];
      PC_Grid.Cells[2,n]:= SchuelerMAC_new[Raum,n];
      PC_Grid.Cells[3,n]:= SchuelerPc_new[Raum,n];
      typ := SchuelerPCTyp_new[Raum,n];
      if typ='' then Typ := 'lin';
      PC_Grid.Cells[4,n]:= Typ;
    end;
end;

procedure TRaumKonfiguration.BT_ZeileClick(Sender: TObject);
Var
   n : integer;
begin
  PC_Grid.RowCount := PC_Grid.RowCount+1;
  n := PC_Grid.RowCount-1;
  PC_Grid.Cells[0,n]:= IntToStr(n);
  PC_Grid.Cells[1,n]:= '';
  PC_Grid.Cells[2,n]:= '';
  PC_Grid.Cells[3,n]:= '';
  PC_Grid.Cells[4,n]:= 'lin';
end;


procedure TRaumKonfiguration.FormShow(Sender: TObject);
begin
  RaumBoxChange(nil);
  PC_Grid.ColCount:=5;
  BT_speichern.Enabled:=false;
  PC_Grid.Cells[1,0]:='IP';
  PC_Grid.Cells[2,0]:='MAC';
  PC_Grid.Cells[3,0]:='Name';
  PC_Grid.Cells[4,0]:='Typ';
  PC_Grid.ColWidths[0] := 25;
  PC_Grid.ColWidths[1] := 110;
  PC_Grid.ColWidths[2] := 140;
  PC_Grid.ColWidths[3] := PC_Grid.Width-335;
  PC_Grid.ColWidths[4] := 40;
end;

procedure TRaumKonfiguration.PC_GridEnter(Sender: TObject);
begin
  veraendert;
end;

procedure TRaumKonfiguration.PC_GridExit(Sender: TObject);
Var
  anz,n,m,z,p   : integer;
  s,ip,MAC,pc,typ : String;
  Fehler      : Boolean;
begin
  anz    := PC_Grid.RowCount-1;
  z      := 0;
  Fehler := false;
  for n := 1 to anz do
    Begin
      ip  := Trim(Pc_Grid.Cells[1,n]);
      mac := Trim(Pc_Grid.Cells[2,n]);
      pc  := Trim(Pc_Grid.Cells[3,n]);
      for m := 1 to length(pc) do
        Begin
          if PC[m]=' ' then PC[m]:='_'
        end;
      Typ := lowercase(Trim(Pc_Grid.Cells[4,n]));
      If (Typ <>'win') and (Typ <>'lin') and (Typ <>'dual') then Typ := 'lin';
      if ip <>'' then
        Begin
          if not ValidIP(ip) then Fehler := True;
          inc(z);
          if (z > PCAnzMax) then break;
          SchuelerIP_new[Raum,z]     := ip;
          SchuelerMAC_new[Raum,z]    := mac;
          SchuelerPC_new[Raum,z]     := pc;
          SchuelerPCTyp_new[Raum,z]  := Typ;
          if SchuelerIP_new[Raum,z]<>SchuelerIP[Raum,z] then veraendert;
          if SchuelerMAC_new[Raum,z]<>SchuelerMAC[Raum,z] then veraendert;
          if SchuelerPC_new[Raum,z]<>SchuelerPC[Raum,z] then veraendert;
          if SchuelerPCTyp_new[Raum,z]<>SchuelerPCTyp[Raum,z] then veraendert;
        end;
    end;
  if (z > PCAnzMax) then
    Begin
      ShowMessage('Die maximale Anzahl der PC ist erreicht ('+IntToStr(PCAnzMax)+' Stück).'+ret+'Es kann kein weiterer PC mehr angelegt werden.');
      z:=z-1;
    end;
  if Fehler then
    Begin
      ShowMessage('Liste enthält ungültige IPs!');
     end;
  PCAnz_new[Raum]:=z;
  RaumBoxChange(nil);
end;

procedure TRaumKonfiguration.BT_SpeichernClick(Sender: TObject);
var
  IniFile   : TIniFile;
  n,m,p     : integer;
  ip,s_MAC,s_IP,MAC  : String;
  s : String;
begin
  for n := 1 to RaumAnz_new do
    Begin
      LehrerIP_new[n]:=Trim(LehrerIP_new[n]);
      RaumName_new[n]:=Trim(RaumName_new[n]);
      if (not validIP(LehrerIP_new[n])) and (LehrerIP_new[n]<>'*') then
        Begin
          ShowMessage('Fehler!'+ret+ret+
                      'Die Lehrer-IP "'+LehrerIP_new[n]+'" im Raum '+IntToStr(n)+' ist ungültig.'+ret+
                      'Das Speichern wird abgebrochen.');
          exit;
        end;
      for m := 1 to PCAnz_new[n] do
        Begin
          if (LehrerIP_new[n]=SchuelerIP_new[n,m]) then
            Begin
             ShowMessage('Fehler!'+ret+ret+
                      'Die Lehrer-IP "'+LehrerIP_new[n]+'" im Raum '+IntToStr(n)+' ist auch als Schüler-IP vorhanden.'+ret+
                      'Das Speichern wird abgebrochen.');
              exit;
            end;
        end;
      s_MAC := '';
      s_IP  := '';
      for m:= 1 to PCAnz_new[n] do
        Begin
          if (SchuelerMAC_new[n,m] <>'') and not ValidMAC(SchuelerMAC_new[n,m]) then
            Begin
              s_MAC:=s_MAC+SchuelerIP_new[n,m]+' --- '+SchuelerMAC_new[n,m]+ret;
            end;
          if (SchuelerIP_new[n,m] <>'') and not ValidIP(SchuelerIP_new[n,m]) then
            Begin
              s_IP:=s_IP+SchuelerIP_new[n,m]+ret;
            end;
        end;
      if s_MAC <>'' then
        Begin
          if MessageDlg('Fehler in den MAC-Adressen!','Die MAC-Adressen im Raum '+IntToStr(n)+' enthalten ungültige Werte.'+ret+ret+s_MAC+ret+
                'Dadurch wird Wake-On-Lan nicht korrekt funktionieren.'+ret+ret+
                'Wollen Sie die Daten trotzdem speichern?',mtConfirmation,[mbYes,mbNo],0) = mrNo
             then exit;
        end;
      if s_IP <>'' then
        Begin
          if MessageDlg('Fehler in den IP-Adressen!','Die IP-Adressen im Raum '+ IntToStr(n)+' enthalten ungültige Werte.'+ret+ret+s_IP+ret+
                'Wollen Sie die Daten trotzdem speichern?',mtConfirmation,[mbYes,mbNo],0) = mrNo
             then exit;
        end;
    end;
  if FileExists(ConfigFilePfad) then
    Begin
      IniFile := TIniFile.Create(ConfigFilePfad);
      Try with IniFile do
        Begin
          WriteInteger(Programm_sec,Raumanzahl_entry,RaumAnz_new);
          for n := 1 to RaumAnz_new do
            Begin
              EraseSection(Raum_sec+IntToStr(n));
              WriteString(Raum_sec+IntToStr(n),RaumName_entry,RaumName_new[n]);
              WriteString(Raum_sec+IntToStr(n),LehrerIP_entry,LehrerIP_new[n]);
              WriteInteger(Raum_sec+IntToStr(n),PCAnz_entry,PCAnz_new[n]);
              for m := 1 to PCAnz_new[n] do
                Begin
                  s := SchuelerIP_new[n,m]+','+SchuelerMAC_new[n,m]
                       + ','+SchuelerPC_new[n,m]+','+SchuelerPCTyp_new[n,m];
                  WriteString(Raum_sec+IntToStr(n),SchuelerIP_entry+IntToStr(m),s);
                  SchuelerIP[n,m]    := SchuelerIP_new[n,m];
                  SchuelerMAC[n,m]   := SchuelerMAC_new[n,m];
                  SchuelerPC[n,m]    := SchuelerPC_new[n,m];
                  SchuelerPCTyp[n,m] := SchuelerPCTyp_new[n,m];
                end;
              PCAnz[n]    := PCAnz_new[n];
              RaumName[n] := RaumName_New[n];
              LehrerIP[n] := LehrerIP_new[n];
            end;
          for n := RaumAnz_new+1 to RaumAnz do
            Begin
              EraseSection(Raum_sec+IntToStr(n));
            end;
          RaumAnz:=RaumAnz_new;
          ShowMessage('Konfigurationsdatei wurde neu geschrieben:'+ret+ret+ConfigFilePfad);
          BT_speichern.Enabled:=false;
        end;
      finally
        IniFile.free;
      end;
    end;
end;

procedure TRaumKonfiguration.BT_workstationsClick(Sender: TObject);
Var
  n,m : integer;
begin
  ImportForm.showmodal;
  if (ImportForm.RAnz = 0) or (ImportForm.ImportOK=false) then exit;
  for n := 1 to ImportForm.Ranz do
    Begin
      if RaumAnz_New = RaumAnzMax then
        Begin
          ShowMessage('Die maximale Anzahl der Räume ist erreicht.'+ret+'Es kann kein weiterer Raum mehr angelegt werden.');
          exit;
        end;
      if ImportForm.IPAnz[n]>0 then
        Begin;
          Inc(RaumAnz_New);
          Raum := RaumAnz_New;
          RaumBox.Items.Add('Raum '+IntToStr(Raum));
          RaumBox.ItemIndex := Raum-1;
          ED_LehrerIP.Text := '*';
          ED_RaumName.Text := ImportForm.Rname[n];
          RaumName_New[RaumAnz_New] := ImportForm.Rname[n];
          LehrerIP_new[RaumAnz_New] := '*';
          PCAnz_new [RaumAnz_new]:= ImportForm.IPanz[n];
          for m := 1 to PCAnz_new[RaumAnz_new] do
            Begin
              SchuelerIP_New[RaumAnz_New,m]    := ImportForm.IPs[n,m];
              SchuelerMAC_New[RaumAnz_New,m]   := ImportForm.MACs[n,m];
              SchuelerPC_New[RaumAnz_New,m]    := ImportForm.PCName[n,m];
              SchuelerPCTyp_New[RaumAnz_New,m] := 'lin';
            end;
          RaumBoxChange(nil);
        end;
    end;
end;



procedure TRaumKonfiguration.BT_neuClick(Sender: TObject);
begin
  if RaumAnz_New = RaumAnzMax then
    Begin
      ShowMessage('Die maximale Anzahl der Räume ist erreicht.'+ret+'Es kann kein weiterer Raum mehr angelegt werden.');
      exit;
    end;
  Inc(RaumAnz_New);
  Raum := RaumAnz_New;
  RaumBox.Items.Add('Raum '+IntToStr(Raum));
  RaumBox.ItemIndex := Raum-1;
  ED_LehrerIP.Text := '10.0.0.0';
  ED_RaumName.Text := 'Raum '+IntToStr(Raum);
  veraendert;
  PC_Grid.RowCount:=2;
  PC_Grid.Cells[1,1] := '10.16.0.0';
  PC_Grid.Cells[2,1] := '00:00:00:00:00:00';
  PC_Grid.Cells[3,1] := '';
  PC_Grid.Cells[4,1] := 'lin';
  PC_GridExit(nil);
end;



procedure TRaumKonfiguration.BT_LoeschClick(Sender: TObject);
Var
  r   : String;
  n,m : integer;
begin
  r := RaumName_New[Raum];
  if MessageDlg('Raum Löschen','Möchten Sie den angezeigten Raum'+ret+r+ret+
                'mit allen Schüler PC ('+IntToStr(PCAnz_New[Raum])+' Stück) löschen?',mtConfirmation,[mbNo,mbYes],0) = mrYes then
    Begin
      For n := Raum to RaumAnz_New-1 do
        Begin
          RaumName_New[n] := RaumName_New[n+1];
          PCAnz_new[n]    := PCAnz_new[n+1];
          LehrerIP_new[n] := LehrerIP_new[n+1];
          for m := 1 to PCAnz_new[n] do
                Begin
                  SchuelerIP_new[n,m]  := SchuelerIP_new[n+1,m];
                  SchuelerMAC_New[n,m] := SchuelerMAC_New[n+1,m];
                  SchuelerPC_New[n,m] := SchuelerPC_New[n+1,m];
                  SchuelerPCTyp_New[n,m] := SchuelerPCTyp_New[n+1,m];
                end;
        end;
      RaumAnz_New := RaumAnz_New-1;
      Raum := 1;
      RaumBox.ItemIndex :=0;
      RaumBox.Items.Delete(RaumAnz_new);
      RaumBoxChange(nil);
      veraendert;
    end;
end;

procedure TRaumKonfiguration.BeendenClick(Sender: TObject);
begin
  if BT_speichern.Enabled then
    if MessageDlg('Konfiguration geändert','Die Konfiguration wurde geändert.'+ret+ret+
                  'Wollen Sie die Änderungen speichern?',mtConfirmation,[mbNo,mbYes],0) = mrYes then
      Begin
        BT_SpeichernClick(nil);
      end;
  close;
end;


procedure TRaumKonfiguration.Ed_RaumNameChange(Sender: TObject);
begin
  RaumName_new[Raum] := ED_RaumName.Text;
  if Raumname[Raum] <> RaumName_new[Raum] then veraendert;
end;

procedure TRaumKonfiguration.Ed_LehrerIPChange(Sender: TObject);
begin
  LehrerIP_new[Raum] := ED_LehrerIP.Text;
  if LehrerIP[Raum] <> LehrerIP_new[Raum] then veraendert;
end;

Procedure TRaumKonfiguration.veraendert;
Begin
  BT_speichern.enabled := True;
end;


end.

